searchNodes=[{"ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html","title":"GoogleApi.FirebaseRules.V1.Api.Projects","type":"module","doc":"API calls for all endpoints tagged Projects."},{"ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_create/4","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_create/4","type":"function","doc":"Create a Release. Release names should reflect the developer&#39;s deployment practices. For example, the release name may include the environment name, application name, application version, or any other name meaningful to the developer. Once a Release refers to a Ruleset, the rules can be enforced by Firebase Rules-enabled services. More than one Release may be &#39;live&#39; concurrently. Consider the following three Release names for projects/foo and the Ruleset to which they refer. Release Name | Ruleset Name --------------------------------|------------- projects/foo/releases/prod | projects/foo/rulesets/uuid123 projects/foo/releases/prod/beta | projects/foo/rulesets/uuid123 projects/foo/releases/prod/v23 | projects/foo/rulesets/uuid456 The table reflects the Ruleset rollout in progress. The prod and prod/beta releases refer to the same Ruleset. However, prod/v23 refers to a new Ruleset. The Ruleset reference for a Release may be updated using the UpdateRelease method. Parameters connection (type: GoogleApi.FirebaseRules.V1.Connection.t) - Connection to server name (type: String.t) - Resource name for the project which owns this Release. Format: projects/{project_id} optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.FirebaseRules.V1.Model.Release.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.FirebaseRules.V1.Model.Release{}} on success {:error, info} on failure"},{"ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_delete/4","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_delete/4","type":"function","doc":"Delete a Release by resource name. Parameters connection (type: GoogleApi.FirebaseRules.V1.Connection.t) - Connection to server name (type: String.t) - Resource name for the Release to delete. Format: projects/{project_id}/releases/{release_id} optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.FirebaseRules.V1.Model.Empty{}} on success {:error, info} on failure"},{"ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_get/4","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_get/4","type":"function","doc":"Get a Release by name. Parameters connection (type: GoogleApi.FirebaseRules.V1.Connection.t) - Connection to server name (type: String.t) - Resource name of the Release. Format: projects/{project_id}/releases/{release_id} optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.FirebaseRules.V1.Model.Release{}} on success {:error, info} on failure"},{"ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_get_executable/4","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_get_executable/4","type":"function","doc":"Get the Release executable to use when enforcing rules. Parameters connection (type: GoogleApi.FirebaseRules.V1.Connection.t) - Connection to server name (type: String.t) - Resource name of the Release. Format: projects/{project_id}/releases/{release_id} optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :executableVersion (type: String.t) - The requested runtime executable version. Defaults to FIREBASE_RULES_EXECUTABLE_V1. opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.FirebaseRules.V1.Model.GetReleaseExecutableResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_list/4","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_list/4","type":"function","doc":"List the Release values for a project. This list may optionally be filtered by Release name, Ruleset name, TestSuite name, or any combination thereof. Parameters connection (type: GoogleApi.FirebaseRules.V1.Connection.t) - Connection to server name (type: String.t) - Resource name for the project. Format: projects/{project_id} optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :filter (type: String.t) - Release filter. The list method supports filters with restrictions on the Release.name, Release.ruleset_name, and Release.test_suite_name. Example 1: A filter of &#39;name=prod*&#39; might return Releases with names within &#39;projects/foo&#39; prefixed with &#39;prod&#39;: Name | Ruleset Name ------------------------------|------------- projects/foo/releases/prod | projects/foo/rulesets/uuid1234 projects/foo/releases/prod/v1 | projects/foo/rulesets/uuid1234 projects/foo/releases/prod/v2 | projects/foo/rulesets/uuid8888 Example 2: A filter of name=prod* ruleset_name=uuid1234 would return only Release instances for &#39;projects/foo&#39; with names prefixed with &#39;prod&#39; referring to the same Ruleset name of &#39;uuid1234&#39;: Name | Ruleset Name ------------------------------|------------- projects/foo/releases/prod | projects/foo/rulesets/1234 projects/foo/releases/prod/v1 | projects/foo/rulesets/1234 In the examples, the filter parameters refer to the search filters are relative to the project. Fully qualified prefixed may also be used. e.g. test_suite_name=projects/foo/testsuites/uuid1 :pageSize (type: integer()) - Page size to load. Maximum of 100. Defaults to 10. Note: page_size is just a hint and the service may choose to load fewer than page_size results due to the size of the output. To traverse all of the releases, the caller should iterate until the page_token on the response is empty. :pageToken (type: String.t) - Next page token for the next batch of Release instances. opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_releases_patch/4","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_releases_patch/4","type":"function","doc":"Update a Release via PATCH. Only updates to the ruleset_name and test_suite_name fields will be honored. Release rename is not supported. To create a Release use the CreateRelease method. Parameters connection (type: GoogleApi.FirebaseRules.V1.Connection.t) - Connection to server name (type: String.t) - Resource name for the project which owns this Release. Format: projects/{project_id} optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.FirebaseRules.V1.Model.Release{}} on success {:error, info} on failure"},{"ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_rulesets_create/4","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_rulesets_create/4","type":"function","doc":"Create a Ruleset from Source. The Ruleset is given a unique generated name which is returned to the caller. Source containing syntactic or semantics errors will result in an error response indicating the first error encountered. For a detailed view of Source issues, use TestRuleset. Parameters connection (type: GoogleApi.FirebaseRules.V1.Connection.t) - Connection to server name (type: String.t) - Resource name for Project which owns this Ruleset. Format: projects/{project_id} optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.FirebaseRules.V1.Model.Ruleset.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.FirebaseRules.V1.Model.Ruleset{}} on success {:error, info} on failure"},{"ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_rulesets_delete/4","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_rulesets_delete/4","type":"function","doc":"Delete a Ruleset by resource name. If the Ruleset is referenced by a Release the operation will fail. Parameters connection (type: GoogleApi.FirebaseRules.V1.Connection.t) - Connection to server name (type: String.t) - Resource name for the ruleset to delete. Format: projects/{project_id}/rulesets/{ruleset_id} optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.FirebaseRules.V1.Model.Empty{}} on success {:error, info} on failure"},{"ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_rulesets_get/4","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_rulesets_get/4","type":"function","doc":"Get a Ruleset by name including the full Source contents. Parameters connection (type: GoogleApi.FirebaseRules.V1.Connection.t) - Connection to server name (type: String.t) - Resource name for the ruleset to get. Format: projects/{project_id}/rulesets/{ruleset_id} optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.FirebaseRules.V1.Model.Ruleset{}} on success {:error, info} on failure"},{"ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_rulesets_list/4","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_rulesets_list/4","type":"function","doc":"List Ruleset metadata only and optionally filter the results by Ruleset name. The full Source contents of a Ruleset may be retrieved with GetRuleset. Parameters connection (type: GoogleApi.FirebaseRules.V1.Connection.t) - Connection to server name (type: String.t) - Resource name for the project. Format: projects/{project_id} optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :filter (type: String.t) - Ruleset filter. The list method supports filters with restrictions on Ruleset.name. Filters on Ruleset.create_time should use the date function which parses strings that conform to the RFC 3339 date/time specifications. Example: create_time &gt; date(&quot;2017-01-01T00:00:00Z&quot;) AND name=UUID-* :pageSize (type: integer()) - Page size to load. Maximum of 100. Defaults to 10. Note: page_size is just a hint and the service may choose to load less than page_size due to the size of the output. To traverse all of the releases, caller should iterate until the page_token is empty. :pageToken (type: String.t) - Next page token for loading the next batch of Ruleset instances. opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.FirebaseRules.V1.Model.ListRulesetsResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.FirebaseRules.V1.Api.Projects.html#firebaserules_projects_test/4","title":"GoogleApi.FirebaseRules.V1.Api.Projects.firebaserules_projects_test/4","type":"function","doc":"Test Source for syntactic and semantic correctness. Issues present, if any, will be returned to the caller with a description, severity, and source location. The test method may be executed with Source or a Ruleset name. Passing Source is useful for unit testing new rules. Passing a Ruleset name is useful for regression testing an existing rule. The following is an example of Source that permits users to upload images to a bucket bearing their user id and matching the correct metadata: Example // Users are allowed to subscribe and unsubscribe to the blog. service firebase.storage { match /users/{userId}/images/{imageName} { allow write: if userId == request.auth.uid &amp;&amp; (imageName.matches(&#39;*.png$&#39;) || imageName.matches(&#39;*.jpg$&#39;)) &amp;&amp; resource.mimeType.matches(&#39;^image/&#39;) } } Parameters connection (type: GoogleApi.FirebaseRules.V1.Connection.t) - Connection to server name (type: String.t) - Tests may either provide source or a Ruleset resource name. For tests against source, the resource name must refer to the project: Format: projects/{project_id} For tests against a Ruleset, this must be the Ruleset resource name: Format: projects/{project_id}/rulesets/{ruleset_id} optional_params (type: keyword()) - Optional parameters :&quot;$.xgafv&quot; (type: String.t) - V1 error format. :access_token (type: String.t) - OAuth access token. :alt (type: String.t) - Data format for response. :callback (type: String.t) - JSONP :fields (type: String.t) - Selector specifying which fields to include in a partial response. :key (type: String.t) - API key. Your API key identifies your project and provides you with API access, quota, and reports. Required unless you provide an OAuth 2.0 token. :oauth_token (type: String.t) - OAuth 2.0 token for the current user. :prettyPrint (type: boolean()) - Returns response with indentations and line breaks. :quotaUser (type: String.t) - Available to use for quota purposes for server-side applications. Can be any arbitrary string assigned to a user, but should not exceed 40 characters. :uploadType (type: String.t) - Legacy upload protocol for media (e.g. &quot;media&quot;, &quot;multipart&quot;). :upload_protocol (type: String.t) - Upload protocol for media (e.g. &quot;raw&quot;, &quot;multipart&quot;). :body (type: GoogleApi.FirebaseRules.V1.Model.TestRulesetRequest.t) - opts (type: keyword()) - Call options Returns {:ok, %GoogleApi.FirebaseRules.V1.Model.TestRulesetResponse{}} on success {:error, info} on failure"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html","title":"GoogleApi.FirebaseRules.V1.Connection","type":"module","doc":"Handle Tesla connections for GoogleApi.FirebaseRules.V1."},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#delete/3","title":"GoogleApi.FirebaseRules.V1.Connection.delete/3","type":"function","doc":"Perform a DELETE request. See request/1 or request/2 for options definition. delete(&quot;/users&quot;) delete(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) delete(client, &quot;/users&quot;) delete(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#delete!/3","title":"GoogleApi.FirebaseRules.V1.Connection.delete!/3","type":"function","doc":"Perform a DELETE request. See request!/1 or request!/2 for options definition. delete!(&quot;/users&quot;) delete!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) delete!(client, &quot;/users&quot;) delete!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#execute/2","title":"GoogleApi.FirebaseRules.V1.Connection.execute/2","type":"function","doc":"Execute a request on this connection Returns {:ok, Tesla.Env.t} - If the call was successful {:error, reason} - If the call failed"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#get/3","title":"GoogleApi.FirebaseRules.V1.Connection.get/3","type":"function","doc":"Perform a GET request. See request/1 or request/2 for options definition. get(&quot;/users&quot;) get(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) get(client, &quot;/users&quot;) get(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#get!/3","title":"GoogleApi.FirebaseRules.V1.Connection.get!/3","type":"function","doc":"Perform a GET request. See request!/1 or request!/2 for options definition. get!(&quot;/users&quot;) get!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) get!(client, &quot;/users&quot;) get!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#head/3","title":"GoogleApi.FirebaseRules.V1.Connection.head/3","type":"function","doc":"Perform a HEAD request. See request/1 or request/2 for options definition. head(&quot;/users&quot;) head(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) head(client, &quot;/users&quot;) head(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#head!/3","title":"GoogleApi.FirebaseRules.V1.Connection.head!/3","type":"function","doc":"Perform a HEAD request. See request!/1 or request!/2 for options definition. head!(&quot;/users&quot;) head!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) head!(client, &quot;/users&quot;) head!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#new/0","title":"GoogleApi.FirebaseRules.V1.Connection.new/0","type":"function","doc":"Configure an authless client connection Returns Tesla.Env.client"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#new/1","title":"GoogleApi.FirebaseRules.V1.Connection.new/1","type":"function","doc":"Configure a client connection using a function which yields a Bearer token. Parameters token_fetcher (type: list(String.t()) -&gt; String.t()) - Callback which provides an OAuth2 token given a list of scopes Returns Tesla.Env.client"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#options/3","title":"GoogleApi.FirebaseRules.V1.Connection.options/3","type":"function","doc":"Perform a OPTIONS request. See request/1 or request/2 for options definition. options(&quot;/users&quot;) options(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) options(client, &quot;/users&quot;) options(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#options!/3","title":"GoogleApi.FirebaseRules.V1.Connection.options!/3","type":"function","doc":"Perform a OPTIONS request. See request!/1 or request!/2 for options definition. options!(&quot;/users&quot;) options!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) options!(client, &quot;/users&quot;) options!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#patch/4","title":"GoogleApi.FirebaseRules.V1.Connection.patch/4","type":"function","doc":"Perform a PATCH request. See request/1 or request/2 for options definition. patch(&quot;/users&quot;, %{name: &quot;Jon&quot;}) patch(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) patch(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) patch(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#patch!/4","title":"GoogleApi.FirebaseRules.V1.Connection.patch!/4","type":"function","doc":"Perform a PATCH request. See request!/1 or request!/2 for options definition. patch!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) patch!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) patch!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) patch!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#post/4","title":"GoogleApi.FirebaseRules.V1.Connection.post/4","type":"function","doc":"Perform a POST request. See request/1 or request/2 for options definition. post(&quot;/users&quot;, %{name: &quot;Jon&quot;}) post(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#post!/4","title":"GoogleApi.FirebaseRules.V1.Connection.post!/4","type":"function","doc":"Perform a POST request. See request!/1 or request!/2 for options definition. post!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) post!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) post!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) post!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#put/4","title":"GoogleApi.FirebaseRules.V1.Connection.put/4","type":"function","doc":"Perform a PUT request. See request/1 or request/2 for options definition. put(&quot;/users&quot;, %{name: &quot;Jon&quot;}) put(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) put(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) put(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#put!/4","title":"GoogleApi.FirebaseRules.V1.Connection.put!/4","type":"function","doc":"Perform a PUT request. See request!/1 or request!/2 for options definition. put!(&quot;/users&quot;, %{name: &quot;Jon&quot;}) put!(&quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;]) put!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}) put!(client, &quot;/users&quot;, %{name: &quot;Jon&quot;}, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#request/2","title":"GoogleApi.FirebaseRules.V1.Connection.request/2","type":"function","doc":"Perform a request Options: :method - the request method, one of [:head, :get, :delete, :trace, :options, :post, :put, :patch] :url - either full url e.g. &quot;http://example.com/some/path&quot; or just &quot;/some/path&quot; if using Tesla.Middleware.BaseUrl :query - a keyword list of query params, e.g. [page: 1, per_page: 100] :headers - a keyworld list of headers, e.g. [{&quot;content-type&quot;, &quot;text/plain&quot;}] :body - depends on used middleware: by default it can be a binary if using e.g. JSON encoding middleware it can be a nested map if adapter supports it it can be a Stream with any of the above :opts - custom, per-request middleware or adapter options Examples: ExampleApi.request(method: :get, url: &quot;/users/path&quot;) You can also use shortcut methods like: ExampleApi.get(&quot;/users/1&quot;) or ExampleApi.post(client, &quot;/users&quot;, %{name: &quot;Jon&quot;})"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#request!/2","title":"GoogleApi.FirebaseRules.V1.Connection.request!/2","type":"function","doc":"Perform request and raise in case of error. This is similar to request/2 behaviour from Tesla 0.x See request/2 for list of available options."},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#trace/3","title":"GoogleApi.FirebaseRules.V1.Connection.trace/3","type":"function","doc":"Perform a TRACE request. See request/1 or request/2 for options definition. trace(&quot;/users&quot;) trace(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) trace(client, &quot;/users&quot;) trace(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#trace!/3","title":"GoogleApi.FirebaseRules.V1.Connection.trace!/3","type":"function","doc":"Perform a TRACE request. See request!/1 or request!/2 for options definition. trace!(&quot;/users&quot;) trace!(&quot;/users&quot;, query: [scope: &quot;admin&quot;]) trace!(client, &quot;/users&quot;) trace!(client, &quot;/users&quot;, query: [scope: &quot;admin&quot;])"},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#t:option/0","title":"GoogleApi.FirebaseRules.V1.Connection.option/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Connection.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Connection.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.Arg.html","title":"GoogleApi.FirebaseRules.V1.Model.Arg","type":"module","doc":"Arg matchers for the mock function. Attributes anyValue (type: GoogleApi.FirebaseRules.V1.Model.Empty.t, default: nil) - Argument matches any value provided. exactValue (type: any(), default: nil) - Argument exactly matches value provided."},{"ref":"GoogleApi.FirebaseRules.V1.Model.Arg.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.Arg.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.Arg.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.Arg.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.Empty.html","title":"GoogleApi.FirebaseRules.V1.Model.Empty","type":"module","doc":"A generic empty message that you can re-use to avoid defining duplicated empty messages in your APIs. A typical example is to use it as the request or the response type of an API method. For instance: service Foo { rpc Bar(google.protobuf.Empty) returns (google.protobuf.Empty); } The JSON representation for Empty is empty JSON object {}. Attributes"},{"ref":"GoogleApi.FirebaseRules.V1.Model.Empty.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.Empty.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.Empty.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.Empty.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.File.html","title":"GoogleApi.FirebaseRules.V1.Model.File","type":"module","doc":"File containing source content. Attributes content (type: String.t, default: nil) - Textual Content. fingerprint (type: String.t, default: nil) - Fingerprint (e.g. github sha) associated with the File. name (type: String.t, default: nil) - File name."},{"ref":"GoogleApi.FirebaseRules.V1.Model.File.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.File.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.File.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.File.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.FunctionCall.html","title":"GoogleApi.FirebaseRules.V1.Model.FunctionCall","type":"module","doc":"Represents a service-defined function call that was invoked during test execution. Attributes args (type: list(any()), default: nil) - The arguments that were provided to the function. function (type: String.t, default: nil) - Name of the function invoked."},{"ref":"GoogleApi.FirebaseRules.V1.Model.FunctionCall.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.FunctionCall.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.FunctionCall.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.FunctionCall.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.FunctionMock.html","title":"GoogleApi.FirebaseRules.V1.Model.FunctionMock","type":"module","doc":"Mock function definition. Mocks must refer to a function declared by the target service. The type of the function args and result will be inferred at test time. If either the arg or result values are not compatible with function type declaration, the request will be considered invalid. More than one FunctionMock may be provided for a given function name so long as the Arg matchers are distinct. There may be only one function for a given overload where all Arg values are Arg.any_value. Attributes args (type: list(GoogleApi.FirebaseRules.V1.Model.Arg.t), default: nil) - The list of Arg values to match. The order in which the arguments are provided is the order in which they must appear in the function invocation. function (type: String.t, default: nil) - The name of the function. The function name must match one provided by a service declaration. result (type: GoogleApi.FirebaseRules.V1.Model.Result.t, default: nil) - The mock result of the function call."},{"ref":"GoogleApi.FirebaseRules.V1.Model.FunctionMock.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.FunctionMock.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.FunctionMock.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.FunctionMock.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.GetReleaseExecutableResponse.html","title":"GoogleApi.FirebaseRules.V1.Model.GetReleaseExecutableResponse","type":"module","doc":"The response for FirebaseRulesService.GetReleaseExecutable Attributes executable (type: String.t, default: nil) - Executable view of the Ruleset referenced by the Release. executableVersion (type: String.t, default: nil) - The Rules runtime version of the executable. language (type: String.t, default: nil) - Language used to generate the executable bytes. rulesetName (type: String.t, default: nil) - Ruleset name associated with the Release executable. syncTime (type: DateTime.t, default: nil) - Optional, indicates the freshness of the result. The response is guaranteed to be the latest within an interval up to the sync_time (inclusive). updateTime (type: DateTime.t, default: nil) - Timestamp for the most recent Release.update_time."},{"ref":"GoogleApi.FirebaseRules.V1.Model.GetReleaseExecutableResponse.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.GetReleaseExecutableResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.GetReleaseExecutableResponse.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.GetReleaseExecutableResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.Issue.html","title":"GoogleApi.FirebaseRules.V1.Model.Issue","type":"module","doc":"Issues include warnings, errors, and deprecation notices. Attributes description (type: String.t, default: nil) - Short error description. severity (type: String.t, default: nil) - The severity of the issue. sourcePosition (type: GoogleApi.FirebaseRules.V1.Model.SourcePosition.t, default: nil) - Position of the issue in the Source."},{"ref":"GoogleApi.FirebaseRules.V1.Model.Issue.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.Issue.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.Issue.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.Issue.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse.html","title":"GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse","type":"module","doc":"The response for FirebaseRulesService.ListReleases. Attributes nextPageToken (type: String.t, default: nil) - The pagination token to retrieve the next page of results. If the value is empty, no further results remain. releases (type: list(GoogleApi.FirebaseRules.V1.Model.Release.t), default: nil) - List of Release instances."},{"ref":"GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.ListReleasesResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.ListRulesetsResponse.html","title":"GoogleApi.FirebaseRules.V1.Model.ListRulesetsResponse","type":"module","doc":"The response for FirebaseRulesService.ListRulesets. Attributes nextPageToken (type: String.t, default: nil) - The pagination token to retrieve the next page of results. If the value is empty, no further results remain. rulesets (type: list(GoogleApi.FirebaseRules.V1.Model.Ruleset.t), default: nil) - List of Ruleset instances."},{"ref":"GoogleApi.FirebaseRules.V1.Model.ListRulesetsResponse.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.ListRulesetsResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.ListRulesetsResponse.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.ListRulesetsResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.Metadata.html","title":"GoogleApi.FirebaseRules.V1.Model.Metadata","type":"module","doc":"Metadata for a Ruleset. Attributes services (type: list(String.t), default: nil) - Services that this ruleset has declarations for (e.g., &quot;cloud.firestore&quot;). There may be 0+ of these."},{"ref":"GoogleApi.FirebaseRules.V1.Model.Metadata.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.Metadata.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.Metadata.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.Metadata.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.Release.html","title":"GoogleApi.FirebaseRules.V1.Model.Release","type":"module","doc":"Release is a named reference to a Ruleset. Once a Release refers to a Ruleset, rules-enabled services will be able to enforce the Ruleset. Attributes createTime (type: DateTime.t, default: nil) - Time the release was created. Output only. name (type: String.t, default: nil) - Resource name for the Release. Release names may be structured app1/prod/v2 or flat app1_prod_v2 which affords developers a great deal of flexibility in mapping the name to the style that best fits their existing development practices. For example, a name could refer to an environment, an app, a version, or some combination of three. In the table below, for the project name projects/foo, the following relative release paths show how flat and structured names might be chosen to match a desired development / deployment strategy. Use Case | Flat Name | Structured Name -------------|---------------------|---------------- Environments | releases/qa | releases/qa Apps | releases/app1_qa | releases/app1/qa Versions | releases/app1_v2_qa | releases/app1/v2/qa The delimiter between the release name path elements can be almost anything and it should work equally well with the release name list filter, but in many ways the structured paths provide a clearer picture of the relationship between Release instances. Format: projects/{project_id}/releases/{release_id} rulesetName (type: String.t, default: nil) - Name of the Ruleset referred to by this Release. The Ruleset must exist the Release to be created. updateTime (type: DateTime.t, default: nil) - Time the release was updated. Output only."},{"ref":"GoogleApi.FirebaseRules.V1.Model.Release.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.Release.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.Release.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.Release.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.Result.html","title":"GoogleApi.FirebaseRules.V1.Model.Result","type":"module","doc":"Possible result values from the function mock invocation. Attributes undefined (type: GoogleApi.FirebaseRules.V1.Model.Empty.t, default: nil) - The result is undefined, meaning the result could not be computed. value (type: any(), default: nil) - The result is an actual value. The type of the value must match that of the type declared by the service."},{"ref":"GoogleApi.FirebaseRules.V1.Model.Result.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.Result.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.Result.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.Result.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.Ruleset.html","title":"GoogleApi.FirebaseRules.V1.Model.Ruleset","type":"module","doc":"Ruleset is an immutable copy of Source with a globally unique identifier and a creation time. Attributes createTime (type: DateTime.t, default: nil) - Time the Ruleset was created. Output only. metadata (type: GoogleApi.FirebaseRules.V1.Model.Metadata.t, default: nil) - The metadata for this ruleset. Output only. name (type: String.t, default: nil) - Name of the Ruleset. The ruleset_id is auto generated by the service. Format: projects/{project_id}/rulesets/{ruleset_id} Output only. source (type: GoogleApi.FirebaseRules.V1.Model.Source.t, default: nil) - Source for the Ruleset."},{"ref":"GoogleApi.FirebaseRules.V1.Model.Ruleset.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.Ruleset.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.Ruleset.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.Ruleset.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.Source.html","title":"GoogleApi.FirebaseRules.V1.Model.Source","type":"module","doc":"Source is one or more File messages comprising a logical set of rules. Attributes files (type: list(GoogleApi.FirebaseRules.V1.Model.File.t), default: nil) - File set constituting the Source bundle."},{"ref":"GoogleApi.FirebaseRules.V1.Model.Source.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.Source.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.Source.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.Source.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.SourcePosition.html","title":"GoogleApi.FirebaseRules.V1.Model.SourcePosition","type":"module","doc":"Position in the Source content including its line, column number, and an index of the File in the Source message. Used for debug purposes. Attributes column (type: integer(), default: nil) - First column on the source line associated with the source fragment. fileName (type: String.t, default: nil) - Name of the File. line (type: integer(), default: nil) - Line number of the source fragment. 1-based."},{"ref":"GoogleApi.FirebaseRules.V1.Model.SourcePosition.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.SourcePosition.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.SourcePosition.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.SourcePosition.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.TestCase.html","title":"GoogleApi.FirebaseRules.V1.Model.TestCase","type":"module","doc":"TestCase messages provide the request context and an expectation as to whether the given context will be allowed or denied. Test cases may specify the request, resource, and function_mocks to mock a function call to a service-provided function. The request object represents context present at request-time. The resource is the value of the target resource as it appears in persistent storage before the request is executed. Attributes expectation (type: String.t, default: nil) - Test expectation. functionMocks (type: list(GoogleApi.FirebaseRules.V1.Model.FunctionMock.t), default: nil) - Optional function mocks for service-defined functions. If not set, any service defined function is expected to return an error, which may or may not influence the test outcome. pathEncoding (type: String.t, default: nil) - Specifies whether paths (such as request.path) are encoded and how. request (type: any(), default: nil) - Request context. The exact format of the request context is service-dependent. See the appropriate service documentation for information about the supported fields and types on the request. Minimally, all services support the following fields and types: Request field | Type ---------------|----------------- auth.uid | string auth.token | map&lt;string, string&gt; headers | map&lt;string, string&gt; method | string params | map&lt;string, string&gt; path | string time | google.protobuf.Timestamp If the request value is not well-formed for the service, the request will be rejected as an invalid argument. resource (type: any(), default: nil) - Optional resource value as it appears in persistent storage before the request is fulfilled. The resource type depends on the request.path value."},{"ref":"GoogleApi.FirebaseRules.V1.Model.TestCase.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.TestCase.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.TestCase.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.TestCase.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.TestResult.html","title":"GoogleApi.FirebaseRules.V1.Model.TestResult","type":"module","doc":"Test result message containing the state of the test as well as a description and source position for test failures. Attributes debugMessages (type: list(String.t), default: nil) - Debug messages related to test execution issues encountered during evaluation. Debug messages may be related to too many or too few invocations of function mocks or to runtime errors that occur during evaluation. For example: Unable to read variable [name: &quot;resource&quot;] errorPosition (type: GoogleApi.FirebaseRules.V1.Model.SourcePosition.t, default: nil) - Position in the Source or Ruleset where the principle runtime error occurs. Evaluation of an expression may result in an error. Rules are deny by default, so a DENY expectation when an error is generated is valid. When there is a DENY with an error, the SourcePosition is returned. E.g. error_position { line: 19 column: 37 } functionCalls (type: list(GoogleApi.FirebaseRules.V1.Model.FunctionCall.t), default: nil) - The set of function calls made to service-defined methods. Function calls are included in the order in which they are encountered during evaluation, are provided for both mocked and unmocked functions, and included on the response regardless of the test state. state (type: String.t, default: nil) - State of the test. visitedExpressions (type: list(GoogleApi.FirebaseRules.V1.Model.VisitedExpression.t), default: nil) - The set of visited permission expressions for a given test. This returns the positions and evaluation results of all visited permission expressions which were relevant to the test case, e.g. match /path { allow read if: &lt;expr&gt; } For a detailed report of the intermediate evaluation states, see the expression_reports field"},{"ref":"GoogleApi.FirebaseRules.V1.Model.TestResult.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.TestResult.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.TestResult.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.TestResult.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.TestRulesetRequest.html","title":"GoogleApi.FirebaseRules.V1.Model.TestRulesetRequest","type":"module","doc":"The request for FirebaseRulesService.TestRuleset. Attributes source (type: GoogleApi.FirebaseRules.V1.Model.Source.t, default: nil) - Optional Source to be checked for correctness. This field must not be set when the resource name refers to a Ruleset. testSuite (type: GoogleApi.FirebaseRules.V1.Model.TestSuite.t, default: nil) - Inline TestSuite to run."},{"ref":"GoogleApi.FirebaseRules.V1.Model.TestRulesetRequest.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.TestRulesetRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.TestRulesetRequest.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.TestRulesetRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.TestRulesetResponse.html","title":"GoogleApi.FirebaseRules.V1.Model.TestRulesetResponse","type":"module","doc":"The response for FirebaseRulesService.TestRuleset. Attributes issues (type: list(GoogleApi.FirebaseRules.V1.Model.Issue.t), default: nil) - Syntactic and semantic Source issues of varying severity. Issues of ERROR severity will prevent tests from executing. testResults (type: list(GoogleApi.FirebaseRules.V1.Model.TestResult.t), default: nil) - The set of test results given the test cases in the TestSuite. The results will appear in the same order as the test cases appear in the TestSuite."},{"ref":"GoogleApi.FirebaseRules.V1.Model.TestRulesetResponse.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.TestRulesetResponse.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.TestRulesetResponse.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.TestRulesetResponse.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.TestSuite.html","title":"GoogleApi.FirebaseRules.V1.Model.TestSuite","type":"module","doc":"TestSuite is a collection of TestCase instances that validate the logical correctness of a Ruleset. The TestSuite may be referenced in-line within a TestRuleset invocation or as part of a Release object as a pre-release check. Attributes testCases (type: list(GoogleApi.FirebaseRules.V1.Model.TestCase.t), default: nil) - Collection of test cases associated with the TestSuite."},{"ref":"GoogleApi.FirebaseRules.V1.Model.TestSuite.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.TestSuite.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.TestSuite.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.TestSuite.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest.html","title":"GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest","type":"module","doc":"The request for FirebaseRulesService.UpdateReleasePatch. Attributes release (type: GoogleApi.FirebaseRules.V1.Model.Release.t, default: nil) - Release to update. updateMask (type: String.t, default: nil) - Specifies which fields to update."},{"ref":"GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.UpdateReleaseRequest.t/0","type":"type","doc":""},{"ref":"GoogleApi.FirebaseRules.V1.Model.VisitedExpression.html","title":"GoogleApi.FirebaseRules.V1.Model.VisitedExpression","type":"module","doc":"Store the position and access outcome for an expression visited in rules. Attributes sourcePosition (type: GoogleApi.FirebaseRules.V1.Model.SourcePosition.t, default: nil) - Position in the Source or Ruleset where an expression was visited. value (type: any(), default: nil) - The evaluated value for the visited expression, e.g. true/false"},{"ref":"GoogleApi.FirebaseRules.V1.Model.VisitedExpression.html#decode/2","title":"GoogleApi.FirebaseRules.V1.Model.VisitedExpression.decode/2","type":"function","doc":"Unwrap a decoded JSON object into its complex fields."},{"ref":"GoogleApi.FirebaseRules.V1.Model.VisitedExpression.html#t:t/0","title":"GoogleApi.FirebaseRules.V1.Model.VisitedExpression.t/0","type":"type","doc":""}]